/*
 * score_matrix_test.cpp
 *
 *  Created on: 2010/09/12
 *      Author: shu
 */

#include <gtest/gtest.h>
#include <string>
#include <stdint.h>
#include "../src/score_matrix.h"
#include "../src/encoder.h"
#include "../src/sequence_type.h"
#include "../src/protein_type.h"
#include "../src/dna_type.h"
#include "../src/score_matrix_reader.h"

using namespace std;

TEST(ScoreMatrixTest, ReadingFileTest)
{
  DnaType type;
  Encoder encoder( type );
  ScoreMatrixReader reader(encoder);
  ScoreMatrix score_matrix = reader.Read("./DNA");
  EXPECT_EQ(string("DNA"), score_matrix.GetName());
  uint32_t number_letters = score_matrix.GetNumberLetters();
  EXPECT_EQ(5, number_letters);
  for (uint32_t i = 0; i < number_letters -1; ++i) {
    for (uint32_t j = 0; j < number_letters-1; ++j) {
      if (i == j) {
        EXPECT_EQ(1, score_matrix.GetMatrix()[number_letters*i + j]);
      } else {
        EXPECT_EQ(-3, score_matrix.GetMatrix()[number_letters*i + j]);
      }
    }
  }
}
